/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Feb 2, 2013                                           */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :RX111                                                 */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/

#include "iodefine.h"
#include "machine.h"
#include "ics_rx111.h"


#define  set_LED1(d)     (PORT3.PODR.BIT.B2=(d))  /* PE1=LED0       */
#define  set_LED2(d)     (PORTB.PODR.BIT.B0=(d))  /* PE2=LED1       */

// DTC̃e[uGAm 0x0000Section1kBm 
#pragma section DTCTABLE
unsigned long dtc_table[256]; // caution allignment 0x000
#pragma section


int  toggle = 0;
int  cnt = 0;
int  iu;
int  iv;
int  iw;
int  vdc;
int  VFBPF;
int  VCSPF1;
int  VAC;
int  AUX0;
int  AUX1;
int  AUX2;
int  VR1;

int  ia = 0;
int  ib = 0;

void main(void);

void main(void)
{
 	
    /* **** Clear protect for Clock and MSTP registers **** */
    SYSTEM.PRCR.WORD = 0xA50B;

    /* **** Set OPCCR **** */
    SYSTEM.OPCCR.BYTE = 0x02;       /* Middle-speed operating mode 1A */

    /* **** Set HOCO  **** */
    //SYSTEM.HOCOWTCR2.BYTE = 0x02;   /* Set HOCO wait time            */
    SYSTEM.HOCOCR.BYTE = 0x00;      /* Start HOCO clock (32MHz)      */
    for(cnt=0; cnt<(7168/4); cnt++);

    /* **** Set PCLKD, PCLKB, BCLK, ICLK and FCLK **** */
    SYSTEM.SCKCR.LONG = 0x00010000; /* PCLKD=PCLKB=ICLK=FCLK=32MHz   */
                                    /* BCLK=16MHz                    */
    /* **** Set HOCO clock as clock source (32MHz) **** */
    SYSTEM.SCKCR3.WORD = 0x0100;

    SYSTEM.MSTPCRA.BIT.MSTPA17 = 0; /* S12AD stop state is canceled  */

    PORT3.PDR.BIT.B2 = 1;     /* P32=LED1                            */
    PORTB.PDR.BIT.B0 = 1;     /* PB0=LED2                            */

    /* **** AD setting ********************************************* */
    S12AD.ADCSR.WORD     = 0x4000;    /* Continuos scan mode         */
    S12AD.ADANSA.WORD    = 0xF81F;    /* an0,1,2,3,4,11,12,13,14,15  */
    S12AD.ADCSR.BIT.ADST = 1;         /* Conversion start            */
   
//  ics_init((void*)(&dtc_table),ICS_SCI1_PC7_PC6, 6);  // CN4
//  ics_init((void*)(&dtc_table),ICS_SCI1_P26_P30, 6);  // CN4
//  ics_init((void*)(&dtc_table),ICS_SCI1_P16_P15, 6);  // CN4
//  ics_init((void*)(&dtc_table),ICS_SCI5_PA4_PA3, 6);  // CN3
//  ics_init((void*)(&dtc_table),ICS_SCI5_PC2_PC3, 6);  // CN3
    ics_init((void*)(&dtc_table),ICS_SCI12_PE1_PE2, 6); // CN1
//  ics_init((void*)(&dtc_table),ICS_SCI12_P14_P17, 6); // CN1

    ia = 0;
    ib = 0;

    while (1)
    {
        toggle = 1 - toggle;
        set_LED1(toggle);

        iu     = S12AD.ADDR0;
        iv     = S12AD.ADDR1;
        VCSPF1 = S12AD.ADDR2;
        vdc    = S12AD.ADDR3;
        VFBPF  = S12AD.ADDR4;
        VR1    = S12AD.ADDR11;
        VAC    = S12AD.ADDR12;
        AUX0   = S12AD.ADDR13;
        AUX1   = S12AD.ADDR14;
        AUX2   = S12AD.ADDR15;

        ia = (ia + 1) & 127;
        ib = -ia;

        ics_watchpoint();

        for(cnt=0;cnt<1000;cnt++) { nop(); }
    }
}


